
#define ECHOPIN 6                            
#define TRIGPIN 7 
int rightside = 12;
int leftside = 13;  

int brakeleft = 8;
int brakeright = 9;

int speedRight = 3;
int speedLeft = 11; // not used in this example
int i;
int motorspeed=0;

int controller[] = {0,0,0,0,0,0,0,0,0};
int count =0;

int Xacc = 25; // X 
int Yacc = 26; // Y 


int valX=0;
int valY=0;

float Sacc = 0.3; // Sensitivity to acceceleration: 1 Sacc = 1.5g


void setup()
{
  Serial.begin(9600);
  pinMode(ECHOPIN, INPUT);
  pinMode(TRIGPIN, OUTPUT);
  pinMode(leftside, OUTPUT);
  pinMode(rightside, OUTPUT);
  pinMode(brakeright, OUTPUT);
  pinMode(brakeleft, OUTPUT);

  pinMode(speedRight, OUTPUT);
  pinMode(speedLeft, OUTPUT);
    
  pinMode(Xacc, OUTPUT);
  pinMode(Yacc, OUTPUT);
  
}

void loop()
{

  
while(Serial.available()>0)
{
  
 if(Serial.parseInt()==1111)
 {
  
 long forspeed = Serial.parseInt();
 long backspeed=Serial.parseInt();
 long leftstring=Serial.parseInt();
 long rightstring=Serial.parseInt();
 long brakestring=Serial.parseInt();
 
 if(brakestring != 1)
 {
   if(forspeed > 0)
   {
     // count++;
      //if (count>10)
      //{
        rangecheck();
      //  count=0;
    //  }
     
     forward(leftstring, rightstring, forspeed);
     //jerk(forspeed);
   }
   else if(backspeed>0)
   {
     forward(0, 0, 255);
     backback(leftstring, rightstring, backspeed);
     //jerk(backspeed);
     
   }
   else
   {
     forward(0,0,0);
   }
 }
 else
 {
   forward(0, 0, 255);
  brake(); 
 }
 
 }


 
} 
  
  
  

//  if(c==119)
//{
//  forwardleft();
//}
//
//if(c==115)
//{
//  backwardleft();
//}
//
//
//if(c==30)
//{
//  forwardright();
//}
//
//if(c==31)
//{
//  backwardright();
//}
//


//jerk();

}

void backback(long leftstring, long rightstring, long backspeed)
{
  if(leftstring==1)
  {
  backwardright(backspeed);
  forwardleft(backspeed);
  }
  else if (rightstring == 1)
  {
    forwardright(backspeed);
    backwardleft(backspeed);
  }
  else
  {
    
   backwardleft(backspeed);
   backwardright(backspeed); 
  }
}

void forward(long leftstring, long rightstring, long forspeed)
{
  if(leftstring==1)
  {
  backwardleft(forspeed);
  forwardright(forspeed);
  }
  else if (rightstring == 1)
  {
    forwardleft(forspeed);
    backwardright(forspeed);
  }
  else
  {
   forwardleft(forspeed);
    forwardright(forspeed); 
  }
}

void forwardleft(long forspeed)
{
  digitalWrite(brakeleft,LOW);
  digitalWrite(leftside, HIGH);
  analogWrite(speedLeft, forspeed);
}

void backwardleft(long backspeed)
{
  digitalWrite(brakeleft,LOW);
  digitalWrite(leftside, LOW);
  analogWrite(speedLeft, backspeed);
}

void forwardright(long forspeed)
{
  digitalWrite(brakeright,LOW);
  digitalWrite(rightside, LOW);
  analogWrite(speedRight, forspeed);
}

void backwardright(long backspeed)
{
  digitalWrite(brakeright,LOW);
  digitalWrite(rightside, HIGH);
  analogWrite(speedRight, backspeed);
}

void rangecheck()
{
   digitalWrite(TRIGPIN, LOW);                   // Set the trigger pin to low for 2uS
  delayMicroseconds(2);
  digitalWrite(TRIGPIN, HIGH);                  // Send a 10uS high to trigger ranging
  delayMicroseconds(10);
  digitalWrite(TRIGPIN, LOW);                   // Send pin low again
  int distance = pulseIn(ECHOPIN, HIGH,5000);        // Read in times pulse
  distance= distance/58;                        // Calculate distance from time of pulse
  //Serial.println(distance);  

if (distance>0 && distance<=15)
{
  digitalWrite(brakeright,HIGH);
  digitalWrite(brakeleft,HIGH);
  delay(1000);
  
//  backwardleft();
//  backwardright();
//  delay(1000);
//  
//  digitalWrite(brakeright,HIGH);
//  digitalWrite(brakeleft,HIGH);
} 
      
}
   
void brake()
{
  digitalWrite(brakeleft,HIGH);
  digitalWrite(brakeright,HIGH);
}
   
void jerk(int jerkspeed)
{

valX = analogRead(Xacc); 
valY = analogRead(Yacc); 

// Serial.println(valX);
//Serial.println(valY);

//Serial.println(valX);
//Serial.println(valY);
while (valX > (350) || valX < (275) || valY > (350) || valY < (275))
{
   analogWrite(speedRight, floor(jerkspeed/2));
   analogWrite(speedLeft, floor(jerkspeed/2));
//Serial.println("s");
valX = analogRead(Xacc); 
valY = analogRead(Yacc);
}

}
   







